//
// Tutorial1.java
//
// A basic JMF tutorial
//
// stage 1
//
// Copyright (C) 1995,1996,1997,1998 RealNetworks, Inc.
// All rights reserved.
//



import javax.media.*;  

public class Tutorial1 implements ControllerListener
{
	private javax.media.Player player = null;


	public static void main(String[] args)
	{
		System.out.println("Welcome to JMF for RealSystem G2 Tutorial1.");

		if (args.length == 0 || args[0] == null || args[0].length() == 0)
		{
			System.out.println("Tutorial1: Usage - java Tutorial1 <url>");
			return;
		}

		new Tutorial1(args[0]);
	}

	public Tutorial1(String urlString)
	{
		// first create MediaLocator

		MediaLocator mrl = new MediaLocator(urlString);

		// create Player object 

		try
		{
			player = Manager.createPlayer(mrl);
		}
		catch (Exception e)
		{
			System.err.println("Tutorial1: Unable to create player for URL = " + urlString);
			System.err.println(e);
			return;
		}

		System.out.println("Tutorial1: beginning playback now.");

		// now we have our player, lets start it! 
		player.addControllerListener(this);
		player.start();
	}

	public void controllerUpdate(ControllerEvent e)
	{
		if (e instanceof EndOfMediaEvent)
		{
			player.close();
		}
	}
}
 
