//
// TutorialPanel
//
// This class is an accesssory for Turorial4, 5 and 6
// 
// Copyright (C) 1995,1996,1997,1998 RealNetworks, Inc.
// All rights reserved.
//


import java.awt.*;
import java.awt.event.*;

import javax.media.*;  



// panel to contain controlpanel and progress bar - only show one at a time
public class TutorialPanel extends java.awt.Panel
{
	private java.awt.Component controlPanel = null;
	private java.awt.Component progBar = null;

	private int nowShowing = 0;
	public final static int CP_SHOWING = 1;
	public final static int PB_SHOWING = 2;

	public boolean isCPShowing()	{ return nowShowing == CP_SHOWING; }
	public boolean isPBShowing()	{ return nowShowing == PB_SHOWING; }

	public TutorialPanel(Component controlPanel, Component progBar, long pctDone)
	{
		setLayout(null);

		this.controlPanel = controlPanel;
		this.progBar = progBar;

		Dimension d = controlPanel.getSize();
		setSize(d);
		progBar.setSize(d);

		controlPanel.setVisible(pctDone == 100 ?true :false);
		progBar.setVisible(pctDone != 100 ?true :false);

		nowShowing = (pctDone != 100 ?PB_SHOWING :CP_SHOWING);

		add(progBar);
		add(controlPanel);

		progBar.setLocation(0, 0);
		controlPanel.setLocation(0, 0);

		validate();
	}

	public void showControlPanel()
	{
		progBar.setVisible(false);
		controlPanel.setVisible(true);
		validate();

		nowShowing = CP_SHOWING;
	}

	public void showProgBar()
	{
		controlPanel.setVisible(false);
		progBar.setVisible(true);
		validate();

		nowShowing = PB_SHOWING;
	}

	public void setSize(int width, int height)
	{
		super.setSize(width, height);
		controlPanel.setSize(width, height);
		progBar.setSize(width, height);
	}
}
