/*
 * TACDlg.java
 *
 * Copyright (C) 1998 RealNetworks, Inc.
 * All rights reserved.
 *  
 * http://www.real.com/devzone
 *
 * This program contains proprietary information of RealNetworks, Inc.,
 * and is licensed subject to restrictions on use and distribution.
 *
 * Demonstrates a title/author/copyright dialog
 */


import java.awt.*;
import java.awt.event.*;

import javax.media.*;

import com.real.media.RMTACControl;


public class TACDlg extends Dialog implements ActionListener
{
	private java.awt.Label label3;
	private java.awt.Label label2;
	private java.awt.Label label1;
	private java.awt.Button closeButton;
	private java.awt.TextField title;
	private java.awt.TextField author;
	private java.awt.TextField copyright;

	private RMTACControl tac = null;

	public TACDlg(Frame parent, String url, com.real.media.RMTACControl tac) 
	{
		super(parent, false);

		this.tac = tac;

		addComponents();

		closeButton.addActionListener(this);

		setTitle(url);

		// Add the frame window event handler
		addWindowListener(new WindowAdapter()	{ 
								public void windowClosing(WindowEvent e)
								{ 
									setVisible(false);
								}
							});
	}

	public void update(String url, com.real.media.RMTACControl tac)
	{
		this.tac = tac;

		setTitle(url);

		title.setText(tac.getTitle());
		author.setText(tac.getAuthor());
		copyright.setText(tac.getCopyright());
	}

	public void actionPerformed(ActionEvent e)	
	{
		if (e.getSource() == closeButton)
		{
			// hide dialog on close
			setVisible(false);
		}
	}

	private void addComponents()
	{
		setLayout(null);
		addNotify();
		resize(insets().left + insets().right + 524,insets().top + insets().bottom + 129);

		label3 = new java.awt.Label("Copyright:",Label.RIGHT);
		label3.reshape(insets().left + 12,insets().top + 93,69,23);
		label3.setFont(new Font("Dialog", Font.BOLD, 12));
		add(label3);

		label2 = new java.awt.Label("Author:",Label.RIGHT);
		label2.reshape(insets().left + 12,insets().top + 53,69,23);
		label2.setFont(new Font("Dialog", Font.BOLD, 12));
		add(label2);

		label1 = new java.awt.Label("Title:",Label.RIGHT);
		label1.reshape(insets().left + 12,insets().top + 13,69,23);
		label1.setFont(new Font("Dialog", Font.BOLD, 12));
		add(label1);

		closeButton = new java.awt.Button("Close");
		closeButton.reshape(insets().left + 432,insets().top + 12,74,30);
		closeButton.setFont(new Font("Dialog", Font.BOLD, 12));
		add(closeButton);

		title = new java.awt.TextField(tac.getTitle());
		title.reshape(insets().left + 94,insets().top + 11,322,28);
		title.setEditable(false);
		add(title);

		author = new java.awt.TextField(tac.getAuthor());
		author.reshape(insets().left + 94,insets().top + 51,322,28);
		author.setEditable(false);
		add(author);

		copyright = new java.awt.TextField(tac.getCopyright());
		copyright.reshape(insets().left + 93,insets().top + 92,322,28);
		copyright.setEditable(false);
		add(copyright);
	}
}
