/****************************************************************************
 * 
 *  $Id: exvsurf.h,v 1.3 2000/05/19 22:57:11 ahamel Exp $
 *  
 *  Copyright (C) 1995,1996,1997 Progressive Networks.
 *  All rights reserved.
 *
 *  This program contains proprietary 
 *  information of Progressive Networks, Inc, and is licensed
 *  subject to restrictions on use and distribution.
 *
 */


#ifndef _EXVSURF_H_
#define _EXVSURF_H_


// forward declares
class ExampleWindowlessSite;



class ExampleVideoSurface : IRMAVideoSurface
{
private:
    virtual ~ExampleVideoSurface();
    void    IntersectRect(PNxRect * pRect, PNxRect* pBox, PNxRect * pRetVal);

protected:
    PRIVATE_DESTRUCTORS_ARE_NOT_A_CRIME

    LONG32		    m_lRefCount;
    IUnknown*		    m_pContext;
    RMABitmapInfoHeader	    m_bitmapInfo;
    ExampleWindowlessSite*   m_pSiteWindowless;
    RMABitmapInfoHeader	    m_lastBitmapInfo;
    UCHAR*		    m_pBitmap;

   
public:

    ExampleVideoSurface(IUnknown* pContext, ExampleWindowlessSite* pSiteWindowless);

    PN_RESULT	Init();

    /*
     *	IUnknown methods
     */
    STDMETHOD(QueryInterface)	(THIS_
				REFIID riid,
				void** ppvObj);

    STDMETHOD_(ULONG32,AddRef)	(THIS);

    STDMETHOD_(ULONG32,Release)	(THIS);

    /*
     * IRMAVideoSurface methods usually called by renderers to
     * Draw on the surface
     */
    STDMETHOD(Blt)		(THIS_
				UCHAR*			/*IN*/	pImageData, 
				RMABitmapInfoHeader*    /*IN*/	pBitmapInfo, 
				REF(PNxRect)		/*IN*/	inDestRect,
				REF(PNxRect)		/*IN*/	inSrcRect);

    STDMETHOD(BeginOptimizedBlt)(THIS_ 
				RMABitmapInfoHeader*    /*IN*/	pBitmapInfo);
    
    STDMETHOD(OptimizedBlt)	(THIS_
				UCHAR*			/*IN*/	pImageBits,
				REF(PNxRect)		/*IN*/	rDestRect, 
				REF(PNxRect)		/*IN*/	rSrcRect);
    
    STDMETHOD(EndOptimizedBlt)	(THIS);

    STDMETHOD(GetOptimizedFormat)(THIS_
				  REF(RMA_COMPRESSION_TYPE) /*OUT*/ ulType);

    STDMETHOD(GetPreferredFormat)(THIS_
				  REF(RMA_COMPRESSION_TYPE) /*OUT*/ ulType);
};

#endif	// _EXVSURF_H_

