/****************************************************************************
 * 
 *  $Id: netswap.h,v 1.3 1997/10/21 21:27:24 christof Exp $
 *
 *  Copyright (C) 1995,1996,1997 RealNetworks, Inc.
 *  All rights reserved.
 *  
 *  http://www.real.com/devzone
 *
 *  This program contains proprietary information of RealNetworks, Inc.,
 *  and is licensed subject to restrictions on use and distribution.
 * 
 *
 *  netswap.h
 *
 *  Sample Netbyte Order support routines for RealMedia Architecture.    
 */


#ifndef NETBYTE_H
#define NETBYTE_H 1

typedef unsigned	short	NetWord, HostWord;
typedef unsigned	long	NetDWord, HostDWord;
#ifdef __cplusplus
	#ifndef NET_ENDIAN
		extern "C" {
		extern NetWord	WToNet(HostWord wHost);
		extern HostWord WToHost(NetWord wNet);
		extern NetDWord DwToNet(HostDWord dwHost);
		extern HostDWord DwToHost(NetDWord dwNet);
		}
	#else
		inline NetWord WToNet(HostWord wHost) {return (wHost);};
		inline HostWord WToHost(NetWord wNet) {return (wNet);};
		inline NetDWord DwToNet(HostDWord dwHost) {return (dwHost);};
		inline HostDWord DwToHost(NetDWord dwNet) {return (dwNet);};
	#endif
#else
	#ifndef NET_ENDIAN
		extern NetWord WToNet(HostWord wHost);
		extern HostWord WToHost(NetWord wNet);
		extern NetDWord DwToNet(HostDWord dwHost);
		extern HostDWord DwToHost(NetDWord dwNet);
	#else
		#define WToNet(wHost)	((NetWord) (wHost))
		#define WToHost(wNet)	((HostWord) (wNet ))
		#define DwToNet(dwHost) ((NetDWord) (dwHost))
		#define DwToHost(dwNet) ((HostDWord) (dwNet	))
	#endif
#endif

int TestBigEndian(void);

/*  Converts 2 byte ints from big endian to little endian or vice versa */
void SwapWordBytes(HostWord *data, int numInts);

/*  Converts 4 byte ints from big endian to little endian or vice versa */
void SwapDWordBytes(HostDWord *data, int numInts);

#endif /* NETBYTE_H */
