
/*
 *  pnmarsh.h
 *
 * $Id: pnmarsh.h,v 1.4 1997/10/21 21:27:25 christof Exp $ 
 *
 *  Copyright (C) 1995,1996,1997 RealNetworks, Inc.
 *  All rights reserved.
 *  
 *  http://www.real.com/devzone
 *
 *  This program contains proprietary information of RealNetworks, Inc.,
 *  and is licensed subject to restrictions on use and distribution.
 *
 *  Marshall parameters
*/





#ifndef _PNMARSH_H_
#define _PNMARSH_H_

inline UINT8
getbyte(UINT8* data)
{
    return *data;
}

/* XXXSMP Should be UINT16 */
inline UINT16
getshort(UINT8* data)
{
    return (data[0]<<8)|data[1];
}

inline INT32
getlong(UINT8* data)
{
    return (getshort(data)<<16)|getshort(data+2);
}

inline void
putbyte(UINT8* data, INT8 v)
{
    *data = v;
}

inline void
putshort(UINT8* data, UINT16 v)
{
    *data++ = (Byte)(v>>8);
    *data++ = (Byte)(v&0xff);
}

inline void
putshort(UINT8* data, int v)
{
    putshort(data,(unsigned short)v);
}

inline void
putshort(UINT8* data, INT16 v)
{
    putshort(data, (unsigned short)v);
}

inline void
putlong(UINT8* data, UINT32 v)
{
    *data++ = (Byte)(v>>24);
    *data++ = (Byte)((v>>16)&0xff);
    *data++ = (Byte)((v>>8)&0xff);
    *data++ = (Byte)(v&0xff);
}

inline UINT8*
addbyte(UINT8* cp, UINT8 data)
{
    *cp = data;
    return cp+1;
}

inline UINT8*
addbyte(UINT8* cp, int data)
{
    *cp = data;
    return cp+1;
}

inline UINT8*
addshort(UINT8* cp, UINT16 data)
{
    putshort(cp, data);
    return cp + 2;
}

inline UINT8*
addlong(UINT8* cp, UINT32 data)
{
    putlong(cp, data);
    return cp + 4;
}

inline UINT8*
addstring(UINT8* cp, const UINT8* string, int len)
{
    memcpy(cp, string, len);
    return cp + len;
}

inline UINT8*
addstring(UINT8* cp, const INT8* string, int len)
{
    memcpy(cp, string, len);
    return cp + len;
}

#endif /* _PNMARSH_H_ */
