/****************************************************************************
 *
 *  $Id: exencode.h,v 1.10 1998/10/08 01:52:36 glennh Exp $
 *
 *  Copyright (C) 1995,1996,1997 RealNetworks, Inc.
 *  All rights reserved.
 *
 *  http://www.real.com/devzone
 *
 *  This program contains proprietary information of RealNetworks, Inc.,
 *  and is licensed subject to restrictions on use and distribution.
 *
 *  exencode.h
 *
 *  Example Encoder for RealMedia Architecture (RMA).
 */ 
#ifndef _EXENCODE_H_
#define _EXENCODE_H_


/****************************************************************************
 * Forward declarations
 */
_INTERFACE IRMACommonClassFactory;


/****************************************************************************
 *
 *  ExampleEncoder Class
 *
 */
class ExampleEncoder : public IRMAEncoder,
		       public IRMAErrorSink,
		       public IRMAEncoderCompletion
{
    public:
    /****** Public Class Methods ******************************************/
     ExampleEncoder(char* address, UINT16 port, UINT32 ulNumPacketsToSend);
    ~ExampleEncoder();
    void Encode(const char* filename);


    /************************************************************************
     *  IRMAEncoder Interface Methods                        ref:  rmaencod.h
     */
    STDMETHOD(InitEncoderResponseDone) (THIS_ PN_RESULT status);
    STDMETHOD(GetFileHeader)           (THIS);
    STDMETHOD(GetStreamHeader)         (THIS_ UINT16 stream);
    STDMETHOD(StartPackets)            (THIS_ UINT16 stream);
    STDMETHOD(StopPackets)             (THIS_ UINT16 stream);


    /************************************************************************
     *  IRMAErrorSink Interface Methods                      ref:  rmaerror.h
     */
   STDMETHOD(ErrorOccurred)
	(THIS_
	 const UINT8 unSeverity,
	 const UINT32 ulRMACode,
	 const UINT32 ulUserCode,
	 const char*  pUserString,
	 const char*  pMoreInfoURL
	);

    /************************************************************************
     * IRMAEncoderCompletion methods			    ref: rmaencod.h
     */
    STDMETHOD(EncoderDone)		(THIS_ 
					 PN_RESULT result);


    /************************************************************************
     *  IUnknown COM Interface Methods                          ref:  pncom.h
     */
    STDMETHOD (QueryInterface ) (THIS_ REFIID ID, void** ppInterfaceObj);
    STDMETHOD_(UINT32, AddRef ) (THIS);
    STDMETHOD_(UINT32, Release) (THIS);


    private:
    /****** Private Class Variables ****************************************/
    INT32                          m_lRefCount;
    IRMACommonClassFactory*        m_pCommonClassFactory;
    IUnknown*                      m_pContext;
    IRMARequest*                   m_pRequest;
    IRMAEncoderResponse*           m_pEncoderResponse;
    IRMAEncoderResponseCompletion* m_pEncoderResponseCompletion;
    BOOL                           m_EncoderDone;
    BOOL                           m_EncoderInitialized;
    BOOL                           m_bPacketsStarted;
    char*                          m_address;
    UINT16                         m_port;
    UINT32                         m_starttime;
    UINT32                         m_ulPacketsToSend;
    UINT32                         m_ulPacketsSent;

    /****** Private Class Methods *****************************************/
    void SendAPacket();
    STDMETHOD(SetupRequest) (THIS_ const char* filename);
    STDMETHOD(HandleResponse) (THIS);
    void Cleanup();
};

#endif
