/****************************************************************************
 * 
 * $Id: main.cpp,v 1.10 1998/06/05 20:56:13 paulm Exp $ 
 *
 *  Copyright (C) 1997 RealNetworks, Inc.
 *  All rights reserved.
 *
 *  http://www.real.com/devzone
 *
 *  This program contains proprietary information of RealNetworks, Inc.,
 *  and is licensed subject to restrictions on use and distribution.
 * 
 *  main.cpp
 *
 *  Example encoder class for the SuperEncoder library.
 *
 */


/****************************************************************************
 * Includes
 */
#include <stdio.h>
#include <stdlib.h>

#ifdef __MWERKS__
    #include <console.h>
#endif

#include "pntypes.h"
#include "pncom.h"
#include "rmafiles.h"
#include "rmaencod.h"
#include "rmaerror.h"

#include "exencode.h"


/****************************************************************************
 *  main
 *
 *  This tiny main program just creates an ExampleEncoder object and starts
 *  it running.  See exencode.cpp for the heart of the encoder.
 */
int
main(int argc, char* argv[])
{
    #ifdef __MWERKS__
    	// Emulate command line on Macintosh
	argc = ccommand( &argv );
    #endif

    ExampleEncoder* pTester;
    if(argc < 4)
    {
	fprintf(stdout, "Usage: %s <host> <port> <filename> [num packets]\n", argv[0]);
    }
    else
    {
	UINT32 ulNumPackets = 0;
	if(argc >= 5)
	{
	    ulNumPackets = atoi(argv[4]);
	}
	pTester = new ExampleEncoder(argv[1], atoi(argv[2]), ulNumPackets);
	pTester->AddRef();
	pTester->Encode(argv[3]);
	pTester->Release();
    }
    return 0;
}
