/****************************************************************************
 * 
 *  $Id: os.h,v 1.1 1998/07/13 22:09:33 glennh Exp $
 *
 *  Copyright (C) 1995,1996,1997 Progressive Networks, Inc.
 *  All rights reserved.
 *
 *  http://www.real.com/devzone
 *
 *  This program contains proprietary 
 *  information of Progressive Networks, Inc, and is licensed
 *  subject to restrictions on use and distribution.
 *
 *
 *  Operating System Dependant defines, functions, and includes
 *
 */

#ifndef _OS_
#define _OS_

#include <stdio.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>

#define stricmp strcasecmp

#include <dlfcn.h>

typedef void* HINSTANCE;

inline HINSTANCE
LoadLibrary(char* pFileName)
{
#if defined(_FREEBSD)
    return dlopen(pFileName, 1);
#else
    return dlopen(pFileName, RTLD_LAZY);
#endif
}

inline void*
GetProcAddress(HINSTANCE pDLL, char* pSymbol)
{
#if defined(_FREEBSD)
    char pNewSymbol[2048];
    sprintf(pNewSymbol, "_%s", pSymbol);
    return dlsym(pDLL, pNewSymbol);
#else
    return dlsym(pDLL, pSymbol);
#endif
}

inline void
FreeLibrary(HINSTANCE pDLL)
{
    dlclose(pDLL);
}

#endif
