#ifndef _EXLIVESS_H
#define _EXLIVESS_H

class CExampleLiveRealPixSlideshow : public IRMALiveRealPixResponse
{
public:
    CExampleLiveRealPixSlideshow();
    virtual ~CExampleLiveRealPixSlideshow();

    // CLiveRealPixSlideshow methods
    PN_RESULT Encode(const char *pszServer,
                     UINT32      ulPort,
                     const char *pszFilename,
                     const char *pszFileList,
                     UINT32      ulWidth,
                     UINT32      ulHeight,
                     UINT32      ulBitrate,
                     const char *pszUsername,
                     const char *pszPassword);

    // IUnknown methods
    STDMETHOD(QueryInterface)   (THIS_ REFIID riid, void **ppvObj);
    STDMETHOD_(ULONG32,AddRef)  (THIS);
    STDMETHOD_(ULONG32,Release) (THIS);

    // IRMALiveRealPixResponse methods
    STDMETHOD(EncoderStarted)   (THIS_ PN_RESULT status, const char *pszHeaderString);
    STDMETHOD(ImageSent)        (THIS_ PN_RESULT status, UINT32 ulImageHandle);
    STDMETHOD(EffectSent)       (THIS_ PN_RESULT status, UINT32 ulEffectHandle);
    STDMETHOD(EncoderStopped)   (THIS_ PN_RESULT status);
    STDMETHOD(ErrorOccurred)    (THIS_ const UINT8   unSeverity,
                                       const ULONG32 ulRMACode,
                                       const ULONG32 ulUserCode,
                                       const char   *pszUserString,
                                       const char   *pszMoreInfoURL);
private:
    enum
    {
        kStateConstructed,
        kStateInitPending,
        kStateInitialized,
        kStateIdle,
        kStateSendCurrentImage,
        kStateSendCurrentImagePending,
        kStateSendCurrentEffect,
        kStateSendCurrentEffectPending,
        kStateSendLastCurrentEffect,
        kStateSendLastCurrentEffectPending,
        kStateSendNextImage,
        kStateSendNextImagePending,
        kStateSendNextEffect,
        kStateSendNextEffectPending,
        kStateStopPending,
        kStateStopped,
        kStateError,
        kStateEncoderError,
        kStateChangingSlides,
        kSleepDuringInit       = 10,
        kSleepDuringSend       = 10,
        kSleepDuringShutdown   = 10,
        kMillisecBetweenStats  = 1000,
        kSleepDuringActiveSend = 50
    };

    struct SlideInfo
    {
        char*  m_pszFileName;
        UINT32 m_ulImageHandle;
        BOOL   m_bImageSent;
        UINT32 m_ulEffectHandle;
        BOOL   m_bEffectSent;
    };

    INT32       m_lRefCount;
    UINT32      m_ulState;
    UINT32      m_ulNumImages;
    SlideInfo** m_ppSlideInfo;
    UINT32      m_ulCurIndex;
    UINT32      m_ulNextIndex;
    UINT32      m_ulInputNextIndex;

    void      DeleteAllSlides();
    void      MilliSleep(UINT32 ulTime);
    BOOL      WasKeyboardHit(char& rcKey);
    PN_RESULT LoadAndInitImage(char*            pszFileName,
                               IRMALiveRealPix* pLiveRealPix,
                               REF(UINT32)      rulHandle);
};

#endif
