#include <stdio.h>
#ifdef _MACINTOSH
#include <stdlib.h>	// atoi()
#endif
#include "pntypes.h"
#include "pncom.h"
#include "rmalvpix.h"
#include "exlivess.h"

int main(int argc, char **argv)
{
    // Check args
    if (argc != 10)
    {
        fprintf(stdout, "Usage: %s server port filename filelist width height bitrate username password\n\n", argv[0]);
        fprintf(stdout, "server:\t\tname or IP address of RealServer\n");
        fprintf(stdout, "port:\t\tport on which pn-encoder is listening (see server.cfg)\n");
        fprintf(stdout, "filename:\tfilename which users enter in player\n");
        fprintf(stdout, "filelist:\ttext file containing slide image filenames\n");
        fprintf(stdout, "width:\t\twidth in pixels of RealPix display window\n");
        fprintf(stdout, "height:\t\theight in pixels of RealPix display window\n");
        fprintf(stdout, "bitrate:\tbitrate in bps\n");
        fprintf(stdout, "username:\tusername to access RealServer\n");
        fprintf(stdout, "password:\tpassword to access RealServer\n");
        return 0;
    }

    // Get the arguments
    char   *pszServer   = argv[1];
    UINT32  ulPort      = (UINT32) atoi(argv[2]);
    char   *pszFilename = argv[3];
    char   *pszFileList = argv[4];
    UINT32  ulWidth     = (UINT32) atoi(argv[5]);
    UINT32  ulHeight    = (UINT32) atoi(argv[6]);
    UINT32  ulBitrate   = (UINT32) atoi(argv[7]);
    char   *pszUsername = argv[8];
    char   *pszPassword = argv[9];

    // Create an CExampleLivePixEncode object
    CExampleLiveRealPixSlideshow *pEncoder = new CExampleLiveRealPixSlideshow();
    if (!pEncoder)
    {
        fprintf(stdout, "Could not create encoder object.\n");
        return 0;
    }
    pEncoder->AddRef();

    // Call the long looping Encode() method
    PN_RESULT retVal = pEncoder->Encode(pszServer, ulPort, pszFilename, pszFileList,
                                        ulWidth, ulHeight, ulBitrate, pszUsername, pszPassword);
    if (retVal != PNR_OK)
    {
        fprintf(stdout, "Encode() returned error.\n");
    }

    // Release the object
    pEncoder->Release();

    return 0;
}


