/****************************************************************************
 * 
 *  $Id: os.h,v 1.1 1999/11/09 00:06:07 ehyche Exp $
 *
 *  Copyright (C) 1995,1996,1997 RealNetworks, Inc.
 *  All rights reserved.
 *
 *  http://www.real.com/devzone
 *
 *  This program contains proprietary information of RealNetworks, Inc.,
 *  and is licensed subject to restrictions on use and distribution.
 *
 *
 *  Operating System Dependant defines, functions, and includes
 *
 */

#ifndef _OS_
#define _OS_

#include <stdio.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>

#define stricmp strcasecmp

#if defined( _WIN32 ) || defined( _WINDOWS )
#include <windows.h>
#endif

#if defined(_UNIX)
#include <dlfcn.h>
#endif

#if (!defined( _WIN32 )) && (!defined( _WINDOWS ))
    typedef void* HINSTANCE;
#endif

#if defined(_UNIX)
inline HINSTANCE
LoadLibrary(char* pFileName)
{
    char  pNewFileName[2048];
    char* pTemp = pNewFileName;

    for (; *pFileName; pFileName++)
    {
	if (*pFileName == '.')
	{
	    const char SUFFIX[] = ".so.6.0";
	    memcpy (pTemp, SUFFIX, sizeof(SUFFIX));
	    return dlopen(pNewFileName, 1);
	}
	else
	{
	    *pTemp++ = *pFileName;
	}
    }

#if defined(_FREEBSD)
    return dlopen(pFileName, 1);
#elif defined(_LINUX)
    return dlopen(pFileName, RTLD_LAZY);
#endif
}
#endif

#if defined(_UNIX)
inline void*
GetProcAddress(HINSTANCE pDLL, char* pSymbol)
{
#if defined(_FREEBSD)
    char pNewSymbol[2048];
    sprintf(pNewSymbol, "_%s", pSymbol);
    return dlsym(pDLL, pNewSymbol);
#else
    return dlsym(pDLL, pSymbol);
#endif
}
#endif

#if defined(_UNIX)
inline void
FreeLibrary(HINSTANCE pDLL)
{
    dlclose(pDLL);
}
#endif

#endif
