#ifndef _EXLIVPIX_H
#define _EXLIVPIX_H

class CExampleLiveRealPixEncode : public IRMALiveRealPixResponse
{
private:
    enum
    {
        kStateConstructed,
        kStateInitPending,
        kStateInitialized,
        kStateIdle,
        kStateCheckFile,
        kStateImageChanged,
        kStateImageSendPending,
        kStateImageSent,
        kStateEffectSendPending,
        kStateEffectSent,
        kStateStopPending,
        kStateStopped,
        kStateError,
        kStateEncoderError,
        kMillisecBetweenStats = 1000,
        kSleepDuringActiveSend = 50
    };

    INT32  m_lRefCount;
    UINT32 m_ulState;
    UINT32 m_ulLastFileSize;
    UINT32 m_ulLastCheckSum;

    PN_RESULT GetCheckSumAndFileSize(const char* pszFileName,
                                     UINT32&     rulCheckSum,
                                     UINT32&     rulFileSize);
public:
    CExampleLiveRealPixEncode();

    ~CExampleLiveRealPixEncode();

    // CLiveRealPixEncode methods
    PN_RESULT Encode(const char *pszServer,
                     UINT32      ulPort,
                     const char *pszFilename,
                     const char *pszImageName,
                     UINT32      ulWidth,
                     UINT32      ulHeight,
                     UINT32      ulBitrate,
                     const char *pszUsername,
                     const char *pszPassword);

    // IUnknown methods
    STDMETHOD(QueryInterface)   (THIS_ REFIID riid, void **ppvObj);
    STDMETHOD_(ULONG32,AddRef)  (THIS);
    STDMETHOD_(ULONG32,Release) (THIS);

    // IRMALiveRealPixResponse methods
    STDMETHOD(EncoderStarted)   (THIS_ PN_RESULT status, const char *pszHeaderString);
    STDMETHOD(ImageSent)        (THIS_ PN_RESULT status, UINT32 ulImageHandle);
    STDMETHOD(EffectSent)       (THIS_ PN_RESULT status, UINT32 ulEffectHandle);
    STDMETHOD(EncoderStopped)   (THIS_ PN_RESULT status);
    STDMETHOD(ErrorOccurred)    (THIS_ const UINT8   unSeverity,
                                       const ULONG32 ulRMACode,
                                       const ULONG32 ulUserCode,
                                       const char   *pszUserString,
                                       const char   *pszMoreInfoURL);
};

#endif
