/****************************************************************************
 * 
 *  $Id: exlivpln.cpp,v 1.10 1997/10/17 23:27:02 christof Exp $
 *
 *  Copyright (C) 1995,1996,1997 RealNetworks, Inc.
 *  All rights reserved.
 *  
 *  http://www.real.com/devzone
 *
 *  This program contains proprietary information of RealNetworks, Inc.,
 *  and is licensed subject to restrictions on use and distribution.
 * 
 *  exlivpln.cpp
 *
 *  An example which shows the use of broadcast services.
 */


/****************************************************************************
 * Defines
 */
#define INITGUID


/****************************************************************************
 * Includes
 */
#include "pntypes.h"
#include "pncom.h"
#include "rmapckts.h"
#include "rmafiles.h"
#include "rmaformt.h"
#include "rmaplugn.h"
#include "rmacomm.h"

#include "exlivpln.h"
#include "exlivobj.h"


/****************************************************************************
 * Globals
 */
ExampleBroadcastFormat* g_example_broadcast_format = NULL;


/****************************************************************************
 *  RMACreateInstance                                        ref:  rmaplugn.h
 *
 *  This routine creates a new instance of the CMyExampleFileFormat class.
 *  It is called when the RMA core application is launched, and whenever
 *  an URL associated with this plug-in is opened.
 */
STDAPI
RMACreateInstance(IUnknown** ppIUnknown)
{
    *ppIUnknown = (IUnknown*)(IRMABroadcastFormatObject*)new ExampleBroadcastObject();
    if (*ppIUnknown)
    {
	(*ppIUnknown)->AddRef();
	return PNR_OK;
    }
    return PNR_OUTOFMEMORY;
}


/****************************************************************************
 *  ExampleBroadcastFormat::ExampleBroadcastFormat           ref:  exlivpln.h
 *
 *  Constructor
 */
ExampleBroadcastFormat::ExampleBroadcastFormat(IUnknown* pContext) :
    m_pContext(pContext)
{
    if(m_pContext)
	m_pContext->AddRef();
}


/****************************************************************************
 *  ExampleBroadcastFormat::~ExampleBroadcastFormat          ref:  exlivpln.h
 *
 *  Destructor
 */
ExampleBroadcastFormat::~ExampleBroadcastFormat()
{
    if(m_pContext)
    {
	m_pContext->Release();
	m_pContext = NULL;
    }
}

