/****************************************************************************
 * 
 *  $Id: os.h,v 1.1 1999/07/19 20:59:25 nhart Exp $
 *
 *  Copyright (C) 1995,1996,1997 RealNetworks, Inc.
 *  All rights reserved.
 *
 *  http://www.real.com/devzone
 *
 *  This program contains proprietary information of RealNetworks, Inc.,
 *  and is licensed subject to restrictions on use and distribution.
 *
 *  Operating System Dependant defines, functions, and includes
 *
 */

#ifndef _OS_
#define _OS_

#include <stdio.h>
#if defined (_SCO_UW)
#include <strings.h>		/* for strcasecmp() */
#endif
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>

#define stricmp strcasecmp

#ifndef _MAX_PATH
#define _MAX_PATH  1024
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

#if defined( _WIN32 ) || defined( _WINDOWS )
#include <windows.h>
#endif

#if defined(_UNIX)
#include <dlfcn.h>
#endif

#ifdef _FREEBSD
#include <stdlib.h>
#endif

#if (!defined( _WIN32 )) && (!defined( _WINDOWS ))
    typedef void* HINSTANCE;
#endif

#if defined(_UNIX)
inline HINSTANCE
LoadLibrary(char* pFileName)
{
#if defined _SCO_SV
    return dlopen(pFileName, RTLD_LAZY|RTLD_GLOBAL);
#else
    return dlopen(pFileName, 1);
#endif
}
#endif

#if defined(_UNIX)
inline void*
GetProcAddress(HINSTANCE pDLL, char* pSymbol)
{
#if defined(_FREEBSD)
    char pNewSymbol[2048];
    sprintf(pNewSymbol, "_%s", pSymbol);
    return dlsym(pDLL, pNewSymbol);
#else
    return dlsym(pDLL, pSymbol);
#endif
}
#endif

#if defined(_UNIX)
inline void
FreeLibrary(HINSTANCE pDLL)
{
    dlclose(pDLL);
}
#endif

#endif
