/****************************************************************************
 * 
 *  $Id: exaumgr.cpp,v 1.1.1.1 1998/12/07 01:51:29 jordanb Exp $
 *
 *  Copyright (C) 1995,1996,1997,1998 RealNetworks, Inc.
 *  All rights reserved.
 *
 *  http://www.real.com/devzone
 *
 *  This program contains proprietary 
 *  information of RealNetworks, Inc, and is licensed
 *  subject to restrictions on use and distribution.
 *
 *
 *  Sample Implementation of Client Context
 *
 */

#include "pntypes.h"
#include "os.h"
#include "pncom.h"
#include "rmaauth.h"
#include "exaumgr.h"
#include <ctype.h>

extern BOOL  bEnableVerboseMode;


ExampleAuthenticationManager::ExampleAuthenticationManager() :
    m_lRefCount(0)
{
}

ExampleAuthenticationManager::~ExampleAuthenticationManager()
{
}

STDMETHODIMP
ExampleAuthenticationManager::QueryInterface(REFIID riid, void**ppvObj)
{
    if(IsEqualIID(riid, IID_IUnknown))
    {
        AddRef();
        *ppvObj = (IUnknown*)(IRMAAuthenticationManager*)this;
        return PNR_OK;
    }
    else if(IsEqualIID(riid, IID_IRMAAuthenticationManager))
    {
        AddRef();
        *ppvObj = (IRMAAuthenticationManager*)this;
        return PNR_OK;
    }
    *ppvObj = NULL;
    return PNR_NOINTERFACE;
}

STDMETHODIMP_(UINT32)
ExampleAuthenticationManager::AddRef()
{
    return InterlockedIncrement(&m_lRefCount);
}

STDMETHODIMP_(UINT32)
ExampleAuthenticationManager::Release()
{
    if (InterlockedDecrement(&m_lRefCount) > 0)
    {
        return m_lRefCount;
    }

    delete this;
    return 0;
}

STDMETHODIMP
ExampleAuthenticationManager::HandleAuthenticationRequest(IRMAAuthenticationManagerResponse* pResponse)
{

    return PNR_FAIL;
}
