/****************************************************************************
 * 
 *  $Id: excontxt.h,v 1.1.1.1 1998/12/07 01:51:29 jordanb Exp $
 *
 *  Copyright (C) 1995,1996,1997,1998 RealNetworks, Inc.
 *  All rights reserved.
 *
 *  http://www.real.com/devzone
 *
 *  This program contains proprietary 
 *  information of RealNetworks, Inc, and is licensed
 *  subject to restrictions on use and distribution.
 *
 *
 *  Example Client Context, Interfaces
 *
 */

struct IUnknown;
class ExampleClientAdviceSink;
class ExampleErrorMessages;
class ExampleAuthenticationManager;

class ExampleClientContext : public IUnknown
{
private:
    LONG32			    m_lRefCount;
    PNxWindow*                      m_pPNxWindow;

    ExampleClientAdviceSink*	    m_pClientSink;
    ExampleErrorSink*		    m_pErrorSink;
    ExampleAuthenticationManager*   m_pAuthMgr;
    ExampleSiteSupplier*	    m_pSiteSupplier;

public:
    ExampleClientContext(PNxWindow* pWindow);
    ~ExampleClientContext();

    void Init(IUnknown*	       /*IN*/ pUnknown);
    void Close();

    /*
     * IUnknown methods
     */
    STDMETHOD(QueryInterface)	(THIS_
				REFIID riid,
				void** ppvObj);

    STDMETHOD_(ULONG32,AddRef)	(THIS);
    STDMETHOD_(ULONG32,Release)	(THIS);
};






