/****************************************************************************
 * 
 *  $Id: exerror.h,v 1.3 2000/02/02 22:07:46 paulm Exp $
 *
 *  Copyright (C) 1995,1996,1997,1998 RealNetworks, Inc.
 *  All rights reserved.
 *
 *  http://www.real.com/devzone
 *
 *  This program contains proprietary 
 *  information of RealNetworks, Inc, and is licensed
 *  subject to restrictions on use and distribution.
 *
 *
 *  Implementation of IRMAErrorMessages
 *
 */

#ifndef _EXAMPLEERRORMESSAGES_
#define _EXAMPLEERRORMESSAGES_

struct IUnknown;
struct IRMAErrorMessages;

class ExampleErrorSink : public IRMAErrorSink
{
public:

     ExampleErrorSink(IUnknown* pUnknown);
    ~ExampleErrorSink();

    /*
     *  IUnknown methods
     */
    STDMETHOD(QueryInterface)	(THIS_
				REFIID riid,
				void** ppvObj);

    STDMETHOD_(ULONG32,AddRef)	(THIS);

    STDMETHOD_(ULONG32,Release)	(THIS);

    /*
     *  IRMAErrorSink methods
     */

    /************************************************************************
     *	Method:
     *	    IRMAErrorSink::ErrorOccurred
     *	Purpose:
     *	    After you have registered your error sink with an IRMAErrorSinkControl 
     *	    (either in the server or player core) this method will be called to 
     *	    report an error, event, or status message.
     *
     *	    The meaning of the arguments is exactly as described in
     *	    rmaerror.h
     */
    STDMETHOD(ErrorOccurred)	(THIS_
				const UINT8	unSeverity,  
				const ULONG32	ulRMACode,
				const ULONG32	ulUserCode,
				const char*	pUserString,
				const char*	pMoreInfoURL
				);

protected:
    LONG32 m_lRefCount;
    IUnknown*			m_pUnknown;

    void   ConvertErrorToString (const ULONG32 ulRMACode, char* pszBuffer);
    IRMABuffer* ExampleErrorSink::GetErrorText(const ULONG32 ulRMACode);
};
#endif /*_EXAMPLEERRORMESSAGES_*/
