/****************************************************************************
 * 
 *  $Id: fivemmap.h,v 1.1.1.1 1998/12/07 01:51:29 jordanb Exp $
 *
 *  Copyright (C) 1995,1996,1997,1998 RealNetworks, Inc.
 *  All rights reserved.
 *
 *  http://www.real.com/devzone
 *
 *  This program contains proprietary 
 *  information of RealNetworks, Inc, and is licensed
 *  subject to restrictions on use and distribution.
 *
 *
 *  The FiveMinuteMap class is a basic map class that was written in five
 *  minutes. You can use it if you dare. It assumes pntypes.h.
 *
 */

#ifndef _FIVEMMAP_H_
#define _FIVEMMAP_H_

#ifndef _PNTYPES_H_
#error FiveMinuteMap assumes pntypes.h.
#endif

class FiveMinuteMap
{
    const int AllocationSize;

    void**  m_pKeyArray;
    void**  m_pValueArray;
    int	    m_nMapSize;
    int	    m_nAllocSize;
    int     m_nCursor;
public:
    FiveMinuteMap()
	: m_pKeyArray(NULL)
	, m_pValueArray(NULL)
	, m_nMapSize(0)
	, m_nAllocSize(0)
        , m_nCursor(0)
	, AllocationSize(10)
	{};

    ~FiveMinuteMap()
	{
	    delete [] m_pKeyArray;
	    delete [] m_pValueArray;
	};

    int  GetCount() {return m_nMapSize;}

    void* GetFirstValue();
    void* GetNextValue();

    BOOL Lookup(void* Key, void*& Value) const;
    void RemoveKey(void* Key);
    void RemoveValue(void* Value);
    void SetAt(void* Key, void* Value);
};

#endif /* _FIVEMMAP_H_ */
