/****************************************************************************
 * 
 *  $Id: winhdrs.h,v 1.6 1998/05/21 21:16:47 rahul Exp $
 *
 *  Copyright (C) 1995,1996,1997 RealNetworks, Inc.
 *  All rights reserved.
 *  
 *  http://www.real.com/devzone
 *
 *  This program contains proprietary information of RealNetworks, Inc.,
 *  and is licensed subject to restrictions on use and distribution.
 * 
 *  winhdrs.cpp
 *
 *  Example application to demonstrate sending and receiving RFC822 headers
 *
 *  NOTE: This example is intended for use with the HTTP protocol only
 *
 */
#ifndef _WINHDRS_H_
#define _WINHDRS_H_


/****************************************************************************
 * Function definitions
 */
typedef PN_RESULT (PNEXPORT_PTR FPRMCREATEENGINE)(IRMAClientEngine** ppEngine);
typedef PN_RESULT (PNEXPORT_PTR FPRMCLOSEENGINE) (IRMAClientEngine* pEngine);


/****************************************************************************
 *
 *  CFSManagerResponse Class
 *
 */
class CFSManagerResponse : public IRMAFileSystemManagerResponse
{
    public:
    /****** Public Class Methods ******************************************/
     CFSManagerResponse();
    ~CFSManagerResponse();


    /************************************************************************
     *  IRMAFileSystemManagerResponse Interface Methods      ref:  rmafiles.h
     */
    STDMETHOD(InitDone) (THIS_ PN_RESULT status);
    STDMETHOD(FileObjectReady) (THIS_ PN_RESULT	status, IUnknown* pObject);
    STDMETHOD(DirObjectReady ) (THIS_ PN_RESULT	status, IUnknown*	pDirObject);


    /************************************************************************
     *  IUnknown COM Interface Methods                          ref:  pncom.h
     */
    STDMETHOD (QueryInterface ) (THIS_ REFIID ID, void** ppInterfaceObj);
    STDMETHOD_(UINT32, AddRef ) (THIS);
    STDMETHOD_(UINT32, Release) (THIS);

    private:
    /****** Private Class Variables ****************************************/
    INT32		m_lRefCount;
};



/****************************************************************************
 *
 *  CFileResponse Class
 *
 */
class CFileResponse : public IRMAFileResponse
{
    public:
    /****** Public Class Methods ******************************************/
     CFileResponse();
    ~CFileResponse();


    /************************************************************************
    *  IRMAFileResponse Interface Methods                   ref:  rmafiles.h
    */
    STDMETHOD(InitDone ) (THIS_ PN_RESULT status);
    STDMETHOD(SeekDone ) (THIS_ PN_RESULT status);
    STDMETHOD(ReadDone ) (THIS_ PN_RESULT status, IRMABuffer* pBuffer);
    STDMETHOD(WriteDone) (THIS_ PN_RESULT status);
    STDMETHOD(CloseDone) (THIS_ PN_RESULT status);


    /************************************************************************
     *  IUnknown COM Interface Methods                          ref:  pncom.h
     */
    STDMETHOD (QueryInterface ) (THIS_ REFIID ID, void** ppInterfaceObj);
    STDMETHOD_(UINT32, AddRef ) (THIS);
    STDMETHOD_(UINT32, Release) (THIS);


    private:
    /****** Private Class Variables ****************************************/
    INT32		m_lRefCount;
};


#endif // ndef _WINHDRS_H_
