/***************************************************************************
 *
 * $Id: reverter.h,v 1.2 2000/04/28 06:34:45 paulm Exp $
 *
 *  Copyright (C) 1995,1996,1997,1998,1999,2000 RealNetworks, Inc.
 *  All rights reserved.
 *  
 *  http://www.real.com/devzone
 *
 *  This program contains proprietary information of RealNetworks, Inc.,
 *  and is licensed subject to restrictions on use and distribution.
 *
 *  reverter.h
 *
 *  Example client side data reverter plug-in for the RealMedia 
 *  Architecture (RMA).
 */

#ifndef _RNREVERT_H
#define _RNREVERT_H

/***************************************************************************
 * Constants
 */
#define MY_PLUGIN_VERSION       0
#define MY_DESCRIPTION         "Example DataReverter"
#define MY_COPYRIGHT           "(c) 1995-2000 RealNetworks, All rights reserved."
#define MY_MORE_INFO_URL       "http://www.real.com"
#define MY_CONVERSION_MIMETYPE "rn-sample-convert-mimetype"

class Reverter : public IRMAPlugin,
		 public IRMADataRevert
{
public:
    Reverter();
    ~Reverter();

    /*
     *	IUnknown methods
     */
    STDMETHOD(QueryInterface)		(THIS_
					REFIID riid,
					void** ppvObj);

    STDMETHOD_(ULONG32,AddRef)		(THIS);

    STDMETHOD_(ULONG32,Release)		(THIS);

    /*
     *	IRMAPlugin methods
     */
    STDMETHOD(GetPluginInfo)	(THIS_
				REF(BOOL)	 /*OUT*/ bMultipleLoad,
				REF(const char*) /*OUT*/ pDescription,
				REF(const char*) /*OUT*/ pCopyright,
				REF(const char*) /*OUT*/ pMoreInfoURL,
				REF(ULONG32)	 /*OUT*/ ulVersionNumber);

    STDMETHOD(InitPlugin)   (THIS_
			    IUnknown*   /*IN*/  pContext);

    /************************************************************************
     *  IRMADataRevert
     */
    STDMETHOD(DataRevertInit) (THIS_ IRMADataRevertResponse* pResponse);

    STDMETHOD(GetDataRevertInfo) (THIS_ REF(const char**)
					ppConversionTypes);
    
    STDMETHOD(RevertFileHeader)	(THIS_ IRMAValues* pFileHeader);
    
    STDMETHOD(RevertStreamHeader)(THIS_ IRMAValues* pStreamHeader);
    
    STDMETHOD(RevertData) (THIS_ IRMAPacket* pPacket);
    
    STDMETHOD(ControlBufferReady) (THIS_ IRMABuffer* pBuffer);


private:
    IRMABuffer* GetRevertedBuffer(IRMABuffer* pSource);
    IRMAValues* GetRevertedHeader(IRMAValues* pHeader);
    static const char* zm_pConvertTypes[];
    INT32 m_lRefCount;
    IUnknown* m_pContext;
    IRMACommonClassFactory* m_pClassFactory;
    IRMADataRevertResponse* m_pResp;
    UINT32 m_ulNumber;
    ULONG32 m_ulRevertHeaders;
};

#endif /* _RNREVERT_H */
